///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Common/AssemblyHelper/EnCDeltaHelper.h 8     5/10/06 8:02p Eaddy $
//
//    File name:	EnCDeltaHelper.h
//   Created By:	Marc Eaddy
//   Created on:	04/23/06
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Common/AssemblyHelper/EnCDeltaHelper.h $
 * 
 * 8     5/10/06 8:02p Eaddy
 * o Closer to multiple weaving
 * 
 * 7     5/03/06 8:15p Eaddy
 * o Now allows IMetaDataImport to come from Wicca
 * 
 * 6     4/28/06 8:01p Eaddy
 * o Figured out how to marshal iCorDebugModule from Wicca
 * 
 * 5     4/23/06 12:39p Eaddy
 * o Attempting to dump the iface passed by Coordinator
 */

#pragma once
#include "resource.h"       // main symbols

#include <cor.h>

#include "..\AssemblyHelper.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CEnCDeltaHelper

class ATL_NO_VTABLE CEnCDeltaHelper :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CEnCDeltaHelper, &CLSID_EnCDeltaHelper>,
	public IDispatchImpl<IEnCDeltaHelper, &IID_IEnCDeltaHelper, &LIBID_AssemblyHelperLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CEnCDeltaHelper();
	virtual ~CEnCDeltaHelper();

DECLARE_REGISTRY_RESOURCEID(IDR_ENCDELTAHELPER)

BEGIN_COM_MAP(CEnCDeltaHelper)
	COM_INTERFACE_ENTRY(IEnCDeltaHelper)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct();
	void FinalRelease();

public:

public:
	STDMETHOD(CreateDeltas)(/*[in]*/ LONGLONG piunkCorModuleOrig,
                            /*[in]*/ BSTR bstrOriginalModulePath, 
							/*[in]*/ BSTR bstrNewModulePath,
							/*[in]*/ BSTR bstrDeltaDir,
							/*[out]*/ BSTR* pbstrMetadataDeltaPath,
							/*[out]*/ BSTR* pbstrILDeltaPath,
							/*[out]*/ BSTR* pbstrDebugMsg);
};

OBJECT_ENTRY_AUTO(__uuidof(EnCDeltaHelper), CEnCDeltaHelper)
