///////////////////////////////////////////////////////////////////////
//  Copyright (c) OnlyInfo Technologies.,Ltd.  All rights reserved.
//
//      $Header: /Common/AxDump.cpp 1     4/28/06 10:07a Eaddy $
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Common/AxDump.cpp $
 * 
 * 1     4/28/06 10:07a Eaddy
 */

#pragma once

#include "StdAfx.h"

#include "AxDump.h" // Me

#pragma warning(disable: 4311)
#pragma warning(disable: 4312)

IFDump::IFDump()
{
	GetSystemInfo(&sysinfo);
	limit = sysinfo.lpMinimumApplicationAddress;
	GetEntriesFromRegistry();
}

IFDump::~IFDump()
{
	Reset();
	ikeys.RemoveAll();
}

BOOL IFDump::GetEntriesFromRegistry()
{
	BOOL Result= FALSE;
	HKEY		hKey1, hKey2;

	ULONG		index1 = 0;
	DWORD		cbName = MAX_PATH;
	TCHAR		tszClsid[MAX_PATH];
	TCHAR		tszSrcName[MAX_PATH];
	DWORD		cbValue = MAX_PATH;

	if (RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Interface"), 0, KEY_READ, &hKey1) == ERROR_SUCCESS)
	{
		while(RegEnumKeyEx(hKey1, index1++, tszClsid, &cbName, NULL, NULL, NULL, NULL) == ERROR_SUCCESS)
		{
			cbName=MAX_PATH;
			if (RegOpenKeyEx(hKey1, tszClsid, 0, KEY_READ, &hKey2) == ERROR_SUCCESS)
			{
				tszSrcName[0] = _T('\0');
				RegQueryValueEx(hKey2,_T(""),NULL,NULL,(LPBYTE)tszSrcName,&cbValue);
				IID iid;
				CComBSTR bstrInterface(tszClsid);
				IIDFromString(bstrInterface,&iid);
				CComBSTR bstrkey(tszSrcName);
				ikeys.SetAt(iid,bstrkey);
				cbValue = MAX_PATH;
				RegCloseKey(hKey2);
			}
			else
				Result = FALSE;
		}

		RegCloseKey(hKey1);
	}

	return FALSE;
}

void IFDump::QueryMem(ULONG* start,CSimpleArray<MEMORY_BASIC_INFORMATION>& array)
{
	MEMORY_BASIC_INFORMATION buf;
	SIZE_T result;
	ULONG* p;
	LPVOID q;

	p = (ULONG*)((ULONG)start & ~(sysinfo.dwPageSize - 1));
	for (;;) {
		q = (LPVOID)(p - sysinfo.dwPageSize);
		if ((ULONG*)q > (ULONG*)p || q < limit) 
			break;
		result = VirtualQuery(q, &buf, sizeof(buf));

		if (result != sizeof(buf) || buf.AllocationBase == 0) 
			break;

		array.Add(buf);
		p = (ULONG*)(buf.AllocationBase);
	}
}

BOOL IFDump::Reset()
{
	POSITION pos1 = lstIF.GetTailPosition();
	while(pos1!=NULL)
	{
		IFPoint* itmIF = lstIF.GetAt(pos1);
		delete itmIF;
		lstIF.GetPrev(pos1);
	}
	lstIF.RemoveAll();
	return TRUE;
}

BOOL IFDump::OutPutResult()
{
	TCHAR sz[0x1000];
	CComBSTR output;

	POSITION pos1 = lstIF.GetTailPosition();
	ULONG paddr0 = 0;
	while(pos1!=NULL)
	{
		IFPoint* itmIF = lstIF.GetAt(pos1);
		ULONG paddr = (ULONG)itmIF->addr;

		MEMORY_BASIC_INFORMATION buf;
		int icount = itmIF->mia.GetSize();
		if(icount>0)
		{
			buf = itmIF->mia[0];

			ATLTRACE("%08x %08x ",buf.BaseAddress,(ULONG)buf.BaseAddress+(ULONG)buf.RegionSize);
		}
		ATLTRACE("\t");

		wsprintf(sz,_T("%d\t%08x\t%08x\t%s\r\n"),itmIF->ikind,itmIF->addr,*itmIF->addr,itmIF->key);
		OutputDebugString(sz);

        //if (itmIF->key == IID_IMarshal)
        //{
        //    IMarshal* piMarshal = itmIF->addr;
        //}
        
        lstIF.GetPrev(pos1);
		paddr0 = paddr;
	}
	return TRUE;
}

BOOL IFDump::AddEntriesFromTypeLib(LPOLESTR szFile)
{
	HRESULT hr = S_FALSE;
	CComPtr<ITypeLib>  ptlib;
	hr = LoadTypeLibEx(szFile, REGKIND_NONE, &ptlib);
	if(FAILED(hr))	return FALSE;

	UINT uicount = ptlib->GetTypeInfoCount();
	for(UINT i=0;i<uicount;i++)
	{
		CComPtr<ITypeInfo> pti;
		hr = ptlib->GetTypeInfo(i,&pti);
		if(FAILED(hr))	break;	
	
		TYPEATTR* pTypeAttr;
		hr = pti->GetTypeAttr(&pTypeAttr);
		if(FAILED(hr))	break;	

		if(pTypeAttr->typekind==TKIND_INTERFACE||pTypeAttr->typekind==TKIND_DISPATCH)
		{
			CComBSTR bstrName;
			hr = pti->GetDocumentation(-1, &bstrName, NULL, NULL, NULL);
			if(SUCCEEDED(hr))	
				ikeys.SetAt(pTypeAttr->guid,bstrName);
		}

		pti->ReleaseTypeAttr(pTypeAttr);
	}
	return TRUE;
}

HRESULT IFDump::DumpIF(CComPtr<IUnknown> spunk,int kind)
{
	if(!spunk) return S_FALSE;
	HRESULT hr = S_FALSE;

	POSITION pos = ikeys.GetStartPosition();
	while(pos!=NULL)
	{
		CComPtr<IUnknown> xxx;
		hr =spunk->QueryInterface(ikeys.GetKeyAt(pos),(void**)&xxx);
		if(hr==S_OK)
		{
			IFPoint* itmIF	= new IFPoint;
			itmIF->addr		= (ULONG**)((INT_PTR)xxx.p);
			itmIF->ikind	= kind;
			itmIF->key		= ikeys.GetValueAt(pos);
			QueryMem((ULONG*)(xxx.p),itmIF->mia);

			POSITION pos1 = lstIF.GetTailPosition();
			if(pos1==NULL)
				lstIF.AddTail(itmIF);
			else
			{
				bool badded = false;
				while(pos1!=NULL)
				{
					IFPoint* curIF = lstIF.GetAt(pos1);

					if((ULONG)(itmIF->addr)<(ULONG)(curIF->addr))
					{
						lstIF.InsertAfter(pos1,itmIF);
						badded = true;
						break;
					}
					if((ULONG)(itmIF->addr)==(ULONG)(curIF->addr))
					{
						curIF->key += _T(" ");
						curIF->key += ikeys.GetValueAt(pos);
						lstIF.SetAt(pos1,curIF);
						badded = true;
						break;
					}
					lstIF.GetPrev(pos1);
				}
				if(!badded)
					lstIF.AddHead(itmIF);
			}
		}
		if(xxx)
		{
			xxx.Release();
			xxx = NULL;
		}
		ikeys.GetNext(pos);
	}
	return hr;
}


#pragma warning(default: 4311) // Pointer truncations warning.
#pragma warning(default: 4312) // Pointer truncations warning.
