//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Attributes/AddAttribute.cs 3     2/24/06 8:17p Eaddy $
//
// Description:
//
//    Handles adding:
//
//       Fields
//       Methods
//       Properties
//       Attributes (NYI)
//       Events (NYI)
//       Delegates (NYI)
//       Classes (NYI)
//
// Remarks:
//
//    NYI = Not Yet Implemented
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Attributes/AddAttribute.cs $
 * 
 * 3     2/24/06 8:17p Eaddy
 * o Initial checkin
 */

using System;
using System.Reflection;

namespace Phx.Aop.Attributes
{
   [AttributeUsage(AttributeTargets.Field | AttributeTargets.Method | AttributeTargets.Property)]
   public class AddAttribute : Attribute
   {
      bool isOverride = false;
      FieldAttributes access = FieldAttributes.Public;

      public AddAttribute()
      { }

      /// <summary>
      /// Does this extension override a virtual method
      /// </summary>
      /// <remarks>
      /// Only applies to attributes attached to methods
      /// </remarks>

      public bool IsOverride
      {
         get
         {
            // Removed assert so it doesn't interfere with debugging
            // which retrieves all the properties automatically

            //Dbg.Assert(AttachedSym != null && AttachedSym.IsFuncSym);
            return this.isOverride;
         }

         set { this.isOverride = value; }
      }

      public FieldAttributes Access
      {
         get { return this.access; }
         set { this.access = value; }
      }
   }
}
