//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/Expressions/PointcutExpression.cs 6     5/05/06 3:37p Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/Expressions/PointcutExpression.cs $
 * 
 * 6     5/05/06 3:37p Eaddy
 * o Added attributes so the debugger skips over methods
 * 
 * 5     3/01/06 2:17a Eaddy
 * o Now uses Phx.Aop library for pointcuts, advice and joinpoint matching
 * 
 * 4     2/26/06 9:12p Eaddy
 * o Now supports joinpoint matching
 * o Changed tabs to 3 spaces to conform with MS standard
 * 
 * 3     2/26/06 7:48p Eaddy
 * 
 * 2     2/24/06 8:17p Eaddy
 * o Initial checkin
 */

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   public abstract class PointcutExpression
   {
      [System.Diagnostics.DebuggerStepThrough]
      public bool matches(System.Text.StringBuilder rhs)
      {
         return innerMatches(rhs) == trueValue;
      }

      [System.Diagnostics.DebuggerStepThrough]
      public bool matches(string rhs)
      {
         return innerMatches(rhs) == trueValue;
      }

      [System.Diagnostics.DebuggerStepThrough]
      public bool matches(IJoinpoint rhs)
      {
         return innerMatches(rhs) == trueValue;
      }

      [System.Diagnostics.DebuggerStepThrough]
      public bool matches(PointcutExpression rhs)
      {
         return innerMatches(rhs) == trueValue;
      }

      public override string ToString()
      {
         if (!trueValue)
            return "!" + innerToString();
         else
            return innerToString();
      }

      public abstract PointcutExpression parse(string expr);

      [System.Diagnostics.DebuggerStepThrough]
      public virtual bool innerMatches(System.Text.StringBuilder rhs)
      {
         return innerMatches(rhs.ToString());
      }
      
      public abstract bool innerMatches(string rhs);
      public abstract bool innerMatches(IJoinpoint rhs);
      public abstract bool innerMatches(PointcutExpression rhs);

      public abstract string innerToString();

      // DATA
      public bool trueValue = true;
   }
}
