//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/ThisPointcutExpression.cs 4     2/26/06 9:12p Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/ThisPointcutExpression.cs $
 * 
 * 4     2/26/06 9:12p Eaddy
 * o Now supports joinpoint matching
 * o Changed tabs to 3 spaces to conform with MS standard
 * 
 * 3     2/26/06 7:48p Eaddy
 * 
 * 2     2/24/06 8:17p Eaddy
 * o Initial checkin
 */

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   public class ThisPointcutExpression : PatternPointcutExpression, IPointcutDesignator
   {
      static public void register()
      {
         PointcutFactory.registerPointcutDesignator(new ThisPointcutExpression());
      }

      public string Name { get { return "this"; } }

      public PointcutExpression create()
      {
         return new ThisPointcutExpression();
      }

      public override bool innerMatches(IJoinpoint rhs)
      {
         return base.innerMatches(rhs.This.ToString());
      }

      public override string innerToString()
      {
         return Name + "(" + base.innerToString() + ")";
      }
   }
}
