//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/WithinCodePointcutExpression.cs 1     4/03/06 12:23a Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/WithinCodePointcutExpression.cs $
 * 
 * 1     4/03/06 12:23a Eaddy
 * o Now supports WithinCode and Within
 * 
 * 2     3/03/06 3:01p Eaddy
 * o Now supports file and line
 * 
 * 1     2/26/06 10:07p Eaddy
 */

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   public class WithinCodePointcutExpression : SignatureExpression, IPointcutDesignator
   {
      public WithinCodePointcutExpression()
         : base(JoinpointType.STATEMENT)
      { }

      static public void register()
      {
         PointcutFactory.registerPointcutDesignator(new WithinCodePointcutExpression());
      }

      public override string Name { get { return "withincode"; } }

      public PointcutExpression create()
      {
         return new WithinCodePointcutExpression();
      }

      public override bool innerMatches(PointcutExpression rhs)
      {
         if (rhs == null)
            return false;

         WithinCodePointcutExpression expRhs = rhs as WithinCodePointcutExpression;
         return expRhs == null ? false : innerMatches(expRhs);
      }
   }
}
