//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Aop/Pointcuts/WithinPointcutExpression.cs 3     4/03/06 12:23a Eaddy $
//
// Description:
//
// Remarks:
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Aop/Pointcuts/WithinPointcutExpression.cs $
 * 
 * 3     4/03/06 12:23a Eaddy
 * o Now supports WithinCode and Within
 * 
 * 2     3/03/06 3:01p Eaddy
 * o Now supports file and line
 * 
 * 1     2/26/06 10:07p Eaddy
 */

using Phx.Aop.Joinpoints;

namespace Phx.Aop.Pointcuts
{
   public class WithinPointcutExpression : PatternPointcutExpression, IPointcutDesignator
   {
      static public void register()
      {
         PointcutFactory.registerPointcutDesignator(new WithinPointcutExpression());
      }

      public string Name { get { return "within"; } }

      public PointcutExpression create()
      {
         return new WithinPointcutExpression();
      }

      public override bool innerMatches(IJoinpoint rhs)
      {
         return base.innerMatches(rhs.Within.DeclaringType);
      }

      public override string innerToString()
      {
         return Name + "(" + base.innerToString() + ")";
      }
   }
}
