//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Morph/Aop/PointcutKind.cs 2     2/24/06 8:27p Eaddy $
//
// Description:
//
//    The kinds of pointcuts we support
//
// See:
//
//    The AspectJ Programming Guide
//
// Remarks:
//
//    NYI = Not Yet Implemented
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Morph/Aop/PointcutKind.cs $
 * 
 * 2     2/24/06 8:27p Eaddy
 * o Added checkin comment
 */

using System;

namespace Phx.Morph.Aop
{
   /// <summary>
   /// The kinds of pointcuts we support
   /// </summary>
   /// <see>
   /// The AspectJ Programming Guide
   /// </see>
   
   public enum PointcutKind
   {
      call,
      execution,
      get,
      set,
      //handler,                 // NYI
      //adviceexecution,         // NYI
      //staticinitialization,    // NYI
      //initialization,          // NYI
      //preinitialization,       // NYI
      within,
      //withincode,              // NYI
      //this,                    // NYI
      //target,                  // NYI
      //args,                    // NYI
      //cflow,                   // NYI
      //cflowbelow,              // NYI
      //if,                      // NYI
   }
}
