//-----------------------------------------------------------------------------
//
// Phoenix
// Copyright (C) Microsoft Corporation.  All Rights Reserved.
//
// $Header: /Wicca/Morpher/Phx.Morph/Editors/MethodEditorFactory.cs 6     5/24/06 8:56a Eaddy $
//
// Description:
//
// Remarks:
//
//
//-----------------------------------------------------------------------------
/**
 * $Log: /Wicca/Morpher/Phx.Morph/Editors/MethodEditorFactory.cs $
 * 
 * 6     5/24/06 8:56a Eaddy
 * o Changed file names but forgot to change class
 * names
 * 
 * 5     5/24/06 1:35a Eaddy
 * o Switched names for MethodWeaver and MethodEditor
 * so now they make sense
 * o Fixed bug where AppendFuncArg didn't work when
 * weaving static methods
 * 
 * 4     5/05/06 6:18p Eaddy
 * o Did some renaming to improve clarity
 * o Can now list current advice and enable/disable (although
 * enable/disable doesn't actually work yet)
 * 
 * 3     3/15/06 2:37p Eaddy
 * o Breakpoint callback value serves as flag
 * 
 * 2     3/15/06 2:31p Eaddy
 * o Now uses a flag to select the weaver
 */

namespace Phx.Morph.Editors
{
   public class MethodEditorFactory
   {
      public static MethodEditor
      CreateEditor
      (
         Phx.Syms.FuncSym funcSym
      )
      {
         if (BreakpointWeaver.BreakpointWeaverCallback != null)
            return new BreakpointWeaver(funcSym);
         else
            return new BinaryWeaver(funcSym);
      }

      public static MethodEditor
      CreateEditor
      (
         TypeEditor typeEditor, 
         Phx.Syms.FuncSym funcSym
      )
      {
         if (BreakpointWeaver.BreakpointWeaverCallback != null)
            return new BreakpointWeaver(typeEditor, funcSym);
         else
            return new BinaryWeaver(typeEditor, funcSym);
      }
   }
}
