using Phx.Aop.Attributes;
using System.Collections;

public interface IAst : IEnumerable
{
   IAst GetChild(int i);
   int ChildCount { get; }
}

public class AstEnum : IEnumerator
{
   IAst parent;
   int index = -1;

   public AstEnum(IAst parent)
   {
      this.parent = parent;
   }

   public object Current
   {
      get
      {
         return parent.GetChild(index);
      }
   }

   public bool MoveNext()
   {
      return ++index < parent.ChildCount;
   }

   public void Reset()
   {
      index = -1;
   }
}


[Extends("Phx.Syms.Sym")]
public class SymAspect : IAst
{
   [Add]
   public IEnumerator GetEnumerator() { return new AstEnum(this); }

   [Add]
   public IAst GetChild(int i) { return null; }

   [Add]
   public int ChildCount { get { return 0; } }
}
