@REM Use 'set _echo=on' to echo all the commands
@if not "%_ECHO%"=="on" @if not "%_ECHO%"=="ON" @echo off

setlocal

REM *****
REM ***** Verify that Phx environment has been setup
REM ***** 

if "%RDKROOT%"=="" echo Must setup Phx environment first && exit /B 1

set MORPH_DIR=%~dp0..\..
set TARGET_DIR=%MORPH_DIR%\bin

REM *****
REM ***** Sets BUILD, BUILD_EXT, PHX_REF, MSIL_REF, X86_REF, MSIL_RT_REF, X86_RT_REF
REM ***** 

call "%MORPH_DIR%\scripts\SetBuildAndPhxRefs.bat"

set Refs=/r:"%TARGET_DIR%\AstAspect.dll"

call :clone %PHX_REF% %*
if not "%errorlevel%"=="0" goto :EOF

set Refs=

call :clone %MSIL_REF% %*
if not "%errorlevel%"=="0" goto :EOF

call :clone %X86_REF% %*
if not "%errorlevel%"=="0" goto :EOF

call :clone %MSIL_RT_REF% %*
if not "%errorlevel%"=="0" goto :EOF

call :clone %X86_RT_REF% %*
if not "%errorlevel%"=="0" goto :EOF

call :clone %C2_EXE% %*
if not "%errorlevel%"=="0" goto :EOF

for %%i in (%FILES_TO_COPY%) do (
	copy "%TARGET_DIR%\%%~xni" "%TARGET_DIR%\%%~xni.orig" > nul
	copy %%i "%TARGET_DIR%" > nul
)

exit /B 0

:clone

copy %1 "%TARGET_DIR%" > nul

if not exist "%TARGET_DIR%\tmp" mkdir "%TARGET_DIR%\tmp"

set InputAssembly="%TARGET_DIR%\%~xn1"
set OutputAssembly="%TARGET_DIR%\tmp\%~xn1"

REM Must specify -noverify because the pe-reader cloning isn't 100%
REM correct.  Custom modifiers aren't propagated and the PE header
REM can't be verified.

REM Specify -noildasm to prevent the metadata dump files from being
REM created.  For Phx.dll these files take a long time to generate
REM and are 72M which means they can't be in Source Depot anyway.

set PDB="%TARGET_DIR%\tmp\%~n1.pdb"

set FILES_TO_COPY=%OutputAssembly% %PDB% %FILES_TO_COPY%

call "%MORPH_DIR%\scripts\morph.bat" -noverify -noildasm %*
goto :eof
