using Phx.Aop;
using Phx.Aop.Attributes;

public class LogReflectionExt
{
   [Advice(AdviceType.before, "call(* System.Reflection.*.*(..))")]
   static public void LogReflection([Signature] string signature,
                             [SourceLocationAttribute.WithinSignature] string withinSignature,
                             [SourceLocationAttribute.FilePath] string filePath,
                             [SourceLocationAttribute.Line] uint line)
   {
      System.Console.WriteLine();
      System.Console.WriteLine("Called {0}()", signature);
      System.Console.WriteLine("   inside {0}()", withinSignature);
      System.Console.WriteLine("   [File: {0}, Line: {1}]",
         System.IO.Path.GetFileName(filePath), line);
   }
}