@REM Use 'set _echo=on' to echo all the commands
@if not "%_ECHO%"=="on" @if not "%_ECHO%"=="ON" @echo off

:CopyAndAssignRefs

REM *****
REM ***** Verify that Phx environment has been setup
REM ***** 

if "%RDKROOT%"=="" echo Must setup Phx environment first && exit /B 1

REM *****
REM ***** Local vars
REM ***** 

set MORPH_DIR=%~dp0..
set REFS_OPTION=

REM *****
REM ***** Verify required environment vars
REM ***** 

call "%MORPH_DIR%\scripts\requireenv.bat" TARGET_DIR "%TARGET_DIR%"
if not "%errorlevel%"=="0" exit /B 1

REM *****
REM ***** Parse command-line options
REM ***** 

call "%MORPH_DIR%\scripts\checkswitch.bat" quiet %*
set QUIET=%errorlevel%

call "%MORPH_DIR%\scripts\checkswitch.bat" verbose %*
set VERBOSE=%errorlevel%

call "%MORPH_DIR%\scripts\checkswitch.bat" skip_build_morph %*
set SKIP_BUILD_MORPH=%errorlevel%

REM *****
REM ***** Copy the dependents and initialize REFS
REM *****

for %%i in (%*) do call :CopyAndAssignRef %%i

goto :eof

:CopyAndAssignRef

REM Ignore command-line options

if "%~x1"=="" exit /b 0

REM Warn if the DLL isn't found

if not exist %1 call :CheckFile %1
if not "%errorlevel%"=="0" exit /b 1

REM Check if the src and dest directories are the same

call :NormalizeDir %TARGET_DIR%

if "%~dp1"=="%RESULT%" goto :skipcopy
if "%~dp1"=="%RESULT%\" goto :skipcopy
if "%~nx1"=="Phx.Morph.dll" if "%SKIP_BUILD_MORPH%"=="1" goto :skipcopy
if "%~nx1"=="Phx.Aop.dll" if "%SKIP_BUILD_MORPH%"=="1" goto :skipcopy
if "%~nx1"=="MorphPlugin.dll" if "%SKIP_BUILD_MORPH%"=="1" goto :skipcopy

if not exist "%TARGET_DIR%" mkdir "%TARGET_DIR%"

REM Copy the DLL
if not "%QUIET%"=="1" if not "%VERBOSE%"=="0" echo Copying %1 to "%TARGET_DIR%"
copy "%~1" "%TARGET_DIR%" > nul

REM Copy the PDB
if exist "%TARGET_DIR%\%~n1.pdb" del "%TARGET_DIR%\%~n1.pdb"
if exist "%~dpn1.pdb" copy "%~dpn1.pdb" "%TARGET_DIR%" > nul

REM Append to REFS
set REFS_OPTION=%REFS_OPTION% /r:%1
set errorlevel=0

goto :eof

:NormalizeDir
set RESULT=%~f1
goto :eof

:skipcopy

if not "%QUIET%"=="1" if not "%VERBOSE%"=="0" echo Skipping copying %1

REM Append to REFS
set REFS_OPTION=%REFS_OPTION% /r:%1

goto :eof

:CheckFile
for %%x in (%1) do set FOUNDFILE=%%~dp$PATH:x%1

if "%FOUNDFILE%"=="" (
	echo Must build '%1' first
	exit /b 1
)

if not exist %FOUNDFILE% (
	echo Must build '%1' first
	exit /b 1
)

goto :eof