@REM Use 'set _echo=on' to echo all the commands
@if not "%_ECHO%"=="on" @if not "%_ECHO%"=="ON" @echo off

setlocal

REM *****
REM ***** Local vars
REM ***** 

set MORPH_DIR=%~dp0..
set WICCA_DIR=%~dp0..\..

set FAILED_RESULTS=
set SUCCEEDED_RESULTS=
set SKIPPED_RESULTS=

REM *****
REM ***** Parse command-line options
REM ***** 

call "%MORPH_DIR%\scripts\checkswitch.bat" quiet %*
set QUIET=%errorlevel%

call "%MORPH_DIR%\scripts\checkswitch.bat" nosummary %*
set NOSUMMARY=%errorlevel%

for /D %%i in (*) do call :testme %%i %*

if "%NOSUMMARY%"=="0" (
	echo.
	echo ========== Test Results Summary =========
	echo Succeeded: %SUCCEEDED_RESULTS%
	echo    Failed: %FAILED_RESULTS%
	echo   Skipped: %SKIPPED_RESULTS%
)

if not "%SUCCEEDED_RESULTS%"=="" (
	echo %SUCCEEDED_RESULTS%> results.succeeded.txt
) else (
	if exist results.succeeded.txt del results.succeeded.txt
)

if not "%SKIPPED_RESULTS%"=="" (
	echo %SKIPPED_RESULTS%> results.skipped.txt
) else (
	if exist results.skipped.txt del results.skipped.txt
)

if not "%FAILED_RESULTS%"=="" (
	echo %FAILED_RESULTS%> results.failed.txt
	exit /B 1
) else (
	if exist results.failed.txt del results.failed.txt
	exit /B 0
)

goto :eof

:testme

if not "%DIRS_TO_IGNORE%"=="" (
	for %%i in (%DIRS_TO_IGNORE%) do if "%%i"=="%1" exit /B 0
)

if "%QUIET%"=="0" echo.
if "%QUIET%"=="0" echo ===== Test: %1 =====

if not "%TEST_INCLUSION_LIST%"=="" (
	for %%i in (%TEST_INCLUSION_LIST%) do if "%%i"=="%1" goto :ContinueTest
	goto :SkipTest
)

if not "%TEST_EXCLUSION_LIST%"=="" (
	for %%i in (%TEST_EXCLUSION_LIST%) do if "%%i"=="%1" goto :SkipTest
	goto :ContinueTest
)

goto :ContinueTest

:SkipTest
call :reportskipped %1
exit /B 0

:ContinueTest

if not exist %1\dotest.bat (
	echo Test script not found: %1\dotest.bat
	call :reportfailed %1
	exit /B 1
)

REM Run the test already!

call %1\dotest.bat %*
if %errorlevel% == 0 (
	call :reportsuccess %1
	exit /B 0
) ELSE (
	call :reportfailed %1
	exit /B 1
)

:reportfailed
if not "%FAILED_RESULTS%"=="" set FAILED_RESULTS=%FAILED_RESULTS%, 
set FAILED_RESULTS=%FAILED_RESULTS%%1
exit /B 1

:reportsuccess
if not "%SUCCEEDED_RESULTS%"=="" set SUCCEEDED_RESULTS=%SUCCEEDED_RESULTS%, 
set SUCCEEDED_RESULTS=%SUCCEEDED_RESULTS%%1
exit /B 0

:reportskipped
if "%QUIET%"=="0" echo Skipping: %1
if not "%SKIPPED_RESULTS%"=="" set SKIPPED_RESULTS=%SKIPPED_RESULTS%, 
set SKIPPED_RESULTS=%SKIPPED_RESULTS%%1
exit /B 0
