using System.Text;
using System.IO;



namespace Wcs.Aop.Joinpoints
{
    public class WcsSourceLocation : Phx.Aop.Joinpoints.ISourceLocation
    {

        // VARIABLES
        public Kunle.CSharpParser.ASTNode node = null;
        uint line = 0;

        public StringBuilder FilePath
        {
            get
            {
                StringBuilder sb = new StringBuilder();
                sb.Append(Path.Combine(node.File.DirectoryName, node.File.FullName));
                return (sb);
            }
        }

        public string FileName
        {
            get
            {
                return (System.IO.Path.GetFileName(FilePath.ToString()));
            }
        }

        public uint Line
        {
            get
            {
                if (line != 0)
                    return line;
                else
                {	// Hasn't been set yet
                    while (node.Line == -1)
                    {
                        node = (Kunle.CSharpParser.ASTNode)node.getFirstChild();
                    }
                    line = (uint)node.Line;
                    return (line);
                }
            }
        }

        public uint Column
        {
            get
            {
                while (node.Line == -1)
                {
                    node = (Kunle.CSharpParser.ASTNode)node.getFirstChild();
                }
                return ((uint)node.Column);
            }
        }



        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();

            sb.Append("[File: ");
            sb.Append(FileName);
            sb.Append(", Line: ");
            sb.Append(Line);
            sb.Append(']');

            return sb.ToString();
        }
    }
}
