@echo off

cls

setlocal

set BASE=c:\projects\wicca\bin

echo.
echo === Cleaning tmp directory ===
del tmp\HelloWorld.* > nul
del tmp\HelloWorld.*.exe > nul
del tmp\HelloWorld.*.pdb > nul
del tmp\HelloWorld.*.dil > nul
del tmp\HelloWorld.*.il > nul
del tmp\HelloWorld.*.dmeta > nul
del tmp\HelloWorld.*.txt > nul
del tmp\HelloWorld.*.res > nul
del tmp\Logging.*

if not exist tmp\nul mkdir tmp > nul

echo.
echo === Building LogAspect.dll ===
csc /debug /nologo /target:library /out:LogAspect.dll /r:Phx.Aop.dll LogAspect.cs
csc /debug /nologo /target:library /out:tmp\LogAspect.dll /r:Phx.Aop.dll LogAspect.cs

echo.
echo === Building HelloWorld.exe ===
csc /debug /nologo /target:exe /out:tmp\HelloWorld.exe HelloWorld.cs

echo.
echo === Run ORIG EXE through PHX.MORPH ===
echo mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.exe !weave !wgo !quit
mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.exe !weave !wgo !quit

REM Delete the delta files created since we only care about the exe/pdb

cd tmp

echo.
echo === Convert ORIG EXE to IL ===
echo ildasm HelloWorld.0.exe /out=HelloWorld.0.il
ildasm HelloWorld.0.exe /out=HelloWorld.0.il

echo.
echo === Dump metadata for ORIG EXE ===
echo ildasm HelloWorld.0.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.0.txt
ildasm HelloWorld.0.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.0.txt

echo.
echo === Create NEW EXE using Wicca and PHX.MORPH ===
cd ..
echo mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.0.exe !weave %BASE%\LogAspect.dll !wgo !quit
mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.0.exe !weave %BASE%\LogAspect.dll !wgo !quit
cd tmp

echo.
echo === Dump metadata for DELTA METADATA created by PHX.MORPH ===
copy HelloWorld.0.0.dmeta HelloWorld.0.0.dmeta.obj > nul
echo ildasm HelloWorld.0.0.dmeta.obj /text /metadata=raw /metadata=heaps /out=HelloWorld.0.0.dmeta.txt
ildasm HelloWorld.0.0.dmeta.obj /text /metadata=raw /metadata=heaps /out=HelloWorld.0.0.dmeta.txt
del HelloWorld.0.0.dmeta.obj

echo.
echo === Convert NEW EXE to IL ===
echo ildasm HelloWorld.0.0.exe /out=HelloWorld.0.0.il
ildasm HelloWorld.0.0.exe /out=HelloWorld.0.0.il

echo.
echo === Dump metadata for NEW EXE ===
echo ildasm HelloWorld.0.0.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.0.0.txt
ildasm HelloWorld.0.0.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.0.0.txt

@REM
@REM Manually diff the IL to create HelloWorld.diff.il
@REM

if not exist %BASE%\HelloWorld.diff.il echo.
if not exist %BASE%\HelloWorld.diff.il echo ERROR: Must manually create HelloWorld.diff.il first!
if not exist %BASE%\HelloWorld.diff.il goto :eof

echo.
echo === Build EXE from IL and DELTA IL using ILASM ===
echo ilasm /quiet /nologo /debug=IMPL HelloWorld.0.il /enc=%BASE%\HelloWorld.diff.il /out=HelloWorld.ilasm.exe
ilasm /quiet /nologo /debug=IMPL HelloWorld.0.il /enc=%BASE%\HelloWorld.diff.il /out=HelloWorld.ilasm.exe

echo.
echo === Dump metadata for ILASM EXE ===
echo ildasm HelloWorld.ilasm.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.ilasm.txt
ildasm HelloWorld.ilasm.exe /text /metadata=raw /metadata=heaps /out=HelloWorld.ilasm.txt

echo.
echo === Dump metadata for DELTA METADATA created by ILASM ===
copy HelloWorld.ilasm.exe.1.dmeta HelloWorld.ilasm.exe.1.dmeta.obj
echo ildasm HelloWorld.ilasm.exe.1.dmeta.obj /text /metadata=raw /metadata=heaps /out=HelloWorld.ilasm.exe.1.dmeta.txt
ildasm HelloWorld.ilasm.exe.1.dmeta.obj /text /metadata=raw /metadata=heaps /out=HelloWorld.ilasm.exe.1.dmeta.txt
del HelloWorld.ilasm.exe.1.dmeta.obj

@REM
@REM Run the original executable and patch it
@REM

cd ..

echo.
echo === Patch EXE using ENC and DELTAs ===
echo mdbg -nologo !run -enc %BASE%\tmp\HelloWorld.ilasm.exe !lo enc !enc %BASE%\tmp\HelloWorld.ilasm.exe %BASE%\HelloWorld.diff.il !go  !remap 0 !go !go !quit
mdbg -nologo !run -enc %BASE%\tmp\HelloWorld.ilasm.exe !lo enc !enc %BASE%\tmp\HelloWorld.ilasm.exe %BASE%\HelloWorld.diff.il !go !remap 0 !go !go !quit

echo.
echo === Patch EXE using WICCA ===
echo mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.0.exe !patch %BASE%\tmp\HelloWorld.0.0.exe !wgo !quit
mdbg -nologo !load wicca !wtype binary !wrun %BASE%\tmp\HelloWorld.0.exe !patch %BASE%\tmp\HelloWorld.0.0.exe !wgo !quit
