using Phx.Aop;
using Phx.Aop.Attributes;

using Columbia.Utilities;

public class LogFileAspect
{
	[Advice(AdviceType.before, "call(* Goblin.Engine...new(..)) && !within(Columbia.Utilities.MyTrace) && !within(LogFileAspect) && !within(Microsoft.Samples..)")]
	public static void logMethodCall(
				[Signature] string signature,
				[SourceLocationAttribute.WithinSignature] string withinSignature,
				[SourceLocationAttribute.FilePath] string fileName,
				[SourceLocationAttribute.Line] uint line)
	{
		MyTrace.WriteLine(withinSignature + "() called " + 
			signature + "() [File: " + fileName + ", Line: " + line + "]");
	}
}
