using Phx.Aop;
using Phx.Aop.Attributes;

public class MonitorAspect
{
	public static int openFiles = 0;
	public const int MAX_FILES = 3;

	[Advice(AdviceType.before, "call(* System.IO.Stream.Close(..))")]
	public static void fileClosed()
	{
		openFiles--;
		System.Console.WriteLine(" * Security monitor: File close registered.  {0} file(s) open.", openFiles);
	}

	[Advice(AdviceType.before, "call(* System.IO.FileStream.new(..))")]
	[Advice(AdviceType.before, "call(* System.IO.File.Open(..))")]
	[Advice(AdviceType.before, "call(* System.IO.FileInfo.Open(..))")]
	[Advice(AdviceType.before, "call(* System.IO.StreamReader.new(string))")]
	public static void fileOpened()
	{
		openFiles++;
		if (openFiles > MAX_FILES) {
			System.Console.WriteLine(" * Security monitor exception: Too many files open.  Aborting.");
			System.Environment.Exit(1);
		} else {
			System.Console.WriteLine(" * Security monitor: File open registered.  {0} file(s) open.", openFiles);
		}
	}
}