using System;
using System.IO;

public class Security {

	public static void Main(string[] argv)
	{
		int count = 0;

		foreach (string filename in argv)
		{
			System.Console.WriteLine();
			System.Console.WriteLine("Opening file {0}.", Path.GetFileName(filename));
			System.Console.WriteLine();

			StreamReader sr;
			FileStream fs;

			switch(count%4)
			{
				case 0:
					fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
					sr = new StreamReader(fs);
					break;
				case 1:
					fs = new FileInfo(filename).Open(FileMode.Open, FileAccess.Read);
					sr = new StreamReader(fs);
					break;
				case 2:
					fs = File.Open(filename, FileMode.Open, FileAccess.Read);
					sr = new StreamReader(fs);
					break;
				case 3:
					sr = new StreamReader(filename);
					break;
				default:
					sr = null; // Can't happen
					break;
			}

			String line;
			while ((line = sr.ReadLine()) != null)
			{
				Console.WriteLine(line);
			}

			// Only close the even files
			if (++count%2 == 0)
			{
				System.Console.WriteLine();
				System.Console.WriteLine("Closing file {0}.", Path.GetFileName(filename));
				System.Console.WriteLine();

				sr.Close();
			}
		}


		System.Type forceLoad1 = typeof(MonitorAspect);
		//System.Type forceLoad2 = typeof(PreventerAspect);
	}
}