@REM Use 'set _echo=on' to echo all the commands
@if not "%_ECHO%"=="on" @if not "%_ECHO%"=="ON" @echo off

setlocal

REM *****
REM ***** Verify that Phx environment has been setup
REM ***** 

if "%RDKROOT%"=="" echo Must setup Phx environment first && exit /B 1

REM *****
REM ***** Local vars
REM ***** 

set MORPH_DIR=%~dp0..\..\Morpher
set WICCA_DIR=%~dp0..\..
set PROJECT_DIR=%WICCA_DIR%\examples\Security
set TARGET_DIR=%WICCA_DIR%\bin

REM *****
REM ***** Build MonitorAspect.dll
REM ***** 

set SRCS=MonitorAspect.cs
set TARGET="%TARGET_DIR%\MonitorAspect.dll"
set TARGET_FLAGS=/target:library /out:%TARGET% 
set REFS="%TARGET_DIR%\Phx.Aop.dll"

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1

REM *****
REM ***** Build PreventerAspect.dll
REM ***** 

set SRCS=PreventerAspect.cs
set TARGET="%TARGET_DIR%\PreventerAspect.dll"
set TARGET_FLAGS=/target:library /out:%TARGET% 
set REFS="%TARGET_DIR%\Phx.Aop.dll"

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1

REM *****
REM ***** Build FileAccess
REM ***** 

set SRCS=Security.cs
set TARGET="%TARGET_DIR%\Security.exe"
set TARGET_FLAGS=/target:exe /out:%TARGET%
set REFS="%TARGET_DIR%\MonitorAspect.dll"

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1
