@REM Use 'set _echo=on' to echo all the commands
@if not "%_ECHO%"=="on" @if not "%_ECHO%"=="ON" @echo off

setlocal

REM *****
REM ***** Verify that Phx environment has been setup
REM ***** 

if "%RDKROOT%"=="" echo Must setup Phx environment first && exit /B 1

REM *****
REM ***** Local vars
REM ***** 

set MORPH_DIR=%~dp0..\..\Morpher
set WICCA_DIR=%~dp0..\..
set PROJECT_DIR=%WICCA_DIR%\examples\SimpleDraw
set TARGET_DIR=%WICCA_DIR%\bin

REM *****
REM ***** Build Attributes.dll and shared aspects
REM ***** 

call "%WICCA_DIR%\examples\Shared\buildall.bat" %*
if not "%errorlevel%"=="0" exit /b 1

REM *****
REM ***** Build ISimpleDraw.dll
REM ***** 

set SRCS=ISimpleDraw.cs Shape.cs Display.cs
set TARGET="%TARGET_DIR%\ISimpleDraw.dll"
set TARGET_FLAGS=/target:library /out:%TARGET% 
set REFS=

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1

REM *****
REM ***** Build DisplayUpdating aspect
REM ***** 

set SRCS=DisplayUpdatingAspect.cs
set TARGET="%TARGET_DIR%\DisplayUpdatingAspect.dll"
set TARGET_FLAGS=/target:library /out:%TARGET% 
set REFS="%TARGET_DIR%\Phx.Aop.dll" "%TARGET_DIR%\ISimpleDraw.dll"

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1

REM *****
REM ***** Build SimpleDraw.exe
REM ***** 

set SRCS=Line.cs Point.cs SimpleDraw.cs
set TARGET="%TARGET_DIR%\SimpleDraw.exe"
set TARGET_FLAGS=/target:exe /out:%TARGET% 
set REFS="%TARGET_DIR%\Phx.Aop.dll" "%TARGET_DIR%\ISimpleDraw.dll" "%TARGET_DIR%\Attributes.dll" "%TARGET_DIR%\DisplayUpdatingAspect.dll" "%TARGET_DIR%\LogAspect.dll"

call "%MORPH_DIR%\scripts\build-csharp.bat" %*
if not "%errorlevel%"=="0" exit /b 1
